<?php
if ( ! defined( 'ABSPATH' ) ) exit; // Exit if accessed directly

    class atkp_bulkimport
    {
        public static $settings;
        
        /**
         * Construct the plugin object
         */
        public function __construct($pluginbase)
        {
            add_action( 'admin_menu', array(&$this, 'admin_menu'));
        }
        
        function admin_menu() {
    
            add_submenu_page(
                    'edit.php?post_type='.ATKP_PRODUCT_POSTTYPE,
                    __('Bulk import', ATKP_PLUGIN_PREFIX),
                    __('Bulk import', ATKP_PLUGIN_PREFIX),            
                    'edit_posts',            
                    'atkp_bulkimport',
                    array(&$this, 'toolkit_bulkimport')          
            );  
        
        }



public function toolkit_bulkimport() {
    if(!is_user_logged_in ())
     wp_die(__('You do not have sufficient permissions to access this page', ATKP_PLUGIN_PREFIX));
    
    $selectedshopid = '';
    $keyword = '';
    $page =  ATKPTools::get_post_parameter(ATKP_PLUGIN_PREFIX.'_page', 'int');;
    $searched = false;
    $searchoption = 'keyword';
    
    $asintype =  ATKPTools::get_post_parameter(ATKP_PLUGIN_PREFIX.'_asintype', 'string');;
    
    if(ATKPTools::exists_post_parameter('nextpage'))
        $page++;
    
    if(ATKPTools::exists_post_parameter('lastpage'))
        $page--;
        
    if($page < 0 || ATKPTools::exists_post_parameter('searchbulk'))
        $page = 1;
        
        if(ATKPTools::exists_post_parameter('searchbulk') || ATKPTools::exists_post_parameter('nextpage') || ATKPTools::exists_post_parameter('lastpage')) {
                        
            $searched = true;
        }
        
    
    if ($searched) {
        if(!is_user_logged_in ()) {
            wp_die(__('You do not have sufficient permissions to access this page', ATKP_PLUGIN_PREFIX));
        }
        
        //wenn die seiten durchgeblättert werden dann wurde keine neue suche ausgeführt
        if(ATKPTools::exists_post_parameter('nextpage') || ATKPTools::exists_post_parameter('lastpage')) {
            $keyword = ATKPTools::get_post_parameter(ATKP_PLUGIN_PREFIX.'_keyword_search', 'string');
            $selectedshopid = ATKPTools::get_post_parameter(ATKP_PLUGIN_PREFIX.'_shop_search', 'string');
            $searchoption = ATKPTools::get_post_parameter(ATKP_PLUGIN_PREFIX.'_option_search', 'string');
        } else {
            $selectedshopid = ATKPTools::get_post_parameter(ATKP_PLUGIN_PREFIX.'_shopid', 'string');
            $keyword = ATKPTools::get_post_parameter(ATKP_PLUGIN_PREFIX.'_keyword', 'string');
            $searchoption = ATKPTools::get_post_parameter(ATKP_PLUGIN_PREFIX.'_searchoption', 'string');
        }
        
    }
    
    
     // wp_nonce_field( plugin_basename( __FILE__ ), 'bulkimport_nonce' ); 
  
  require_once ATKP_PLUGIN_DIR.'/includes/shopproviders/atkp_shop_provider_base.php';
  
     ?>       

   <h2 class="nav-tab-wrapper">
   <?php
 _e('Bulk import', ATKP_PLUGIN_PREFIX); 
?>
    </h2>
<form method="POST" action="?post_type=atkp_product&page=atkp_bulkimport">

 <table class="form-table">
                        <tr valign="top">
                            <th scope="row">
                                <label for="">
                                    <?php _e('Shop', ATKP_PLUGIN_PREFIX) ?>:
                                </label> 
                            </th>
                            <td>
                            <select id="<?php echo ATKP_PLUGIN_PREFIX.'_shopid' ?>" name="<?php echo ATKP_PLUGIN_PREFIX.'_shopid' ?>" style="width:300px">                            
                                <?php
                                
                                require_once ATKP_PLUGIN_DIR.'/includes/atkp_shop.php';
                                
                                $shps = atkp_shop::get_list($selectedshopid);
                                
                                foreach($shps as $shp) {
                                    if ($shp->selected == true) 
                                            $sel = ' selected'; 
                                        else 
                                            $sel = '';
                                                                                
                                    echo '<option value="' .$shp->id . '"' . $sel . ' > ' .  esc_attr($shp->title) . '</option>';
                                }
                                
                                ?>
                            </select>
                                
                               
                            
                             </td>
                        </tr>
                        
                        <tr valign="top">
                            <th scope="row">
                                <label id="searchcaption" for="">
                                    <?php _e('Create with this key', ATKP_PLUGIN_PREFIX) ?>:
                                </label> 
                            </th>
                            <td>
                                <select name="<?php echo ATKP_PLUGIN_PREFIX.'_asintype' ?>" id="<?php echo ATKP_PLUGIN_PREFIX.'_asintype' ?>" style="width:150px">
                                    <?php
                                    
                                    if($asintype == '' || $asintype == null)
                                        $asintype = 'ASIN';
                                    
                                    $durations = array(
                                                        'ASIN' => __('Unique productid', ATKP_PLUGIN_PREFIX),
                                                        'EAN' => __('EAN', ATKP_PLUGIN_PREFIX),
                                                        'TITLE' => __('Title', ATKP_PLUGIN_PREFIX),   
                                                      );
                                    
                                    foreach ($durations as $value => $name) {
                                        if ($value == $asintype) 
                                            $sel = ' selected'; 
                                        else 
                                            $sel = '';
                                               
                                        echo '<option value="' . $value . '"' . $sel . '>' . esc_attr($name) . '</option>';
                                    } ?>
                                </select> 
                            </td>
                        </tr>
                                                
                        <tr valign="top">
                            <th scope="row">
                                <label id="searchcaption" for="">
                                    <?php _e('Keyword', ATKP_PLUGIN_PREFIX) ?>:
                                </label> 
                            </th>
                            <td>
                                <input type="text" style="width:300px" id="keyword" name="<?php echo ATKP_PLUGIN_PREFIX ?>_keyword" value="<?php echo $keyword ?>">   <br />     <br />                        
                                
                                <input type="radio" id="searchoption1" name="<?php echo ATKP_PLUGIN_PREFIX ?>_searchoption" <?php if($searchoption == 'keyword') echo 'checked="checked"'; ?> value="keyword" /> <label for="searchoption1"><?php _e('Keyword', ATKP_PLUGIN_PREFIX) ?></label>
                                <input type="radio" id="searchoption2" name="<?php echo ATKP_PLUGIN_PREFIX ?>_searchoption" <?php if($searchoption == 'asin') echo 'checked="checked"'; ?> value="asin" /> <label for="searchoption2"><?php _e('ASIN(s)', ATKP_PLUGIN_PREFIX) ?></label>
                                <input type="radio" id="searchoption3" name="<?php echo ATKP_PLUGIN_PREFIX ?>_searchoption" <?php if($searchoption == 'ean') echo 'checked="checked"'; ?> value="ean" /> <label for="searchoption3"><?php _e('EAN(s)', ATKP_PLUGIN_PREFIX) ?></label>

                                 <br />    <br />   
                                
                                <input type="submit" style="margin-top:5px" name="searchbulk" id="searchproduct-button" class="button primary-button" title="<?php _e( 'Search', ATKP_PLUGIN_PREFIX)?>" value="<?php _e( 'Search', ATKP_PLUGIN_PREFIX)?>" />
                                
                                
                                
                                
                                
                                <input type="hidden" id="page" name="<?php echo ATKP_PLUGIN_PREFIX ?>_page" value="<?php echo $page ?>"> 
                                <input type="hidden" id="keyword_search" name="<?php echo ATKP_PLUGIN_PREFIX ?>_keyword_search" value="<?php echo $keyword ?>">
                                <input type="hidden" id="shop_search" name="<?php echo ATKP_PLUGIN_PREFIX ?>_shop_search" value="<?php echo $selectedshopid ?>">
                                <input type="hidden" id="option_search" name="<?php echo ATKP_PLUGIN_PREFIX ?>_option_search" value="<?php echo $searchoption ?>">
                            </td>
                        </tr>
                        
                        
                                            
                        
                        
                      
   </table>


<?php
$result;
if ($searched) {
        require_once ATKP_PLUGIN_DIR.'/includes/atkp_shop.php';
            
        $shop = atkp_shop::load($selectedshopid);
        
        if($shop != null && $shop->provider != null) {
            $shop->provider->checklogon($shop);
            
            try {
                $result = $shop->provider->quick_search($keyword, $searchoption == 'asin' || $searchoption == 'ean' ? $searchoption : 'product', $page);
                
                ?>
                <table class="wp-list-table widefat fixed striped" style="width:99%">
                	<thead>
                	<tr>
                        <th scope="col" class="manage-column" style="width: 100px;text-align:center">
                			<?php _e('Image', ATKP_PLUGIN_PREFIX) ?>
                		</th>
                
                		<th scope="col" class="manage-column column-primary">
                			<?php _e('Title', ATKP_PLUGIN_PREFIX) ?>
                		</th>
                
                		<th scope="col" class="manage-column">
                			<?php _e('Custom Fields', ATKP_PLUGIN_PREFIX) ?>
                		</th>
                		
                		<th scope="col" class="manage-column" style="width:210px"">
                			<?php _e('Status', ATKP_PLUGIN_PREFIX) ?>
                		</th>
                
                	</tr>
                	</thead>
                
                	<tbody>
                
                <?php
                require_once  ATKP_PLUGIN_DIR.'/includes/atkp_udfield.php';
                 $newfields = atkp_udfield::load_fields();
                               $taxonomies = atkp_udtaxonomy::load_taxonomies();
                 require_once  ATKP_PLUGIN_DIR.'/includes/helper/atkp_control_helper.php';
                 $helper = new atkp_control_helper();
                
                    
                $list = array();
                foreach ($taxonomies as $taxonomy ) {
                    if(!$taxonomy->showui)
                        continue;
                        
                    array_push($list, str_replace('-', '_', 'atkp-tax-'.$taxonomy->name) .': $j(\'#atkp-tax-'.$taxonomy->name.'-\'+$asin).val()');                                    
                }
                
                foreach ($newfields as $newfield ) {
                   //html controls überspringen
                    if($newfield->type == 5)
                        continue;
                      
                    array_push($list, str_replace('-', '_', 'atkp-field-'.$newfield->name) .': $j(\'#atkp-field-'.$newfield->name.'-\'+$asin).val()');
                }
                
                $wooenabled = get_option(ATKP_PLUGIN_PREFIX.'_woo_activate',0);
                
                foreach($result as $product) {
                $asin = $product['asin'];    
                    ?>
                    
                    <tr>
                        <td style="text-align:center">
                			<?php  if(isset($product['imageurl'])) { echo '<img src="'.$product['imageurl'].'" style="max-width: 100px;" />'; }  ?>
                		</td>
                
                		<td>
                			<input type="text" style="width:100%" id="atkp-title-<?php echo $product['asin'] ?>" value="<?php echo esc_attr($product['title']) ?>" />  <br />
                			ASIN: <?php echo $asin; ?>, EAN: <?php if(isset($product['ean'])) { echo $product['ean']; } else { echo '-';} ?><br />
                			<a href="<?php echo $product['producturl']; ?>" target="_blank"><?php echo __('View product', ATKP_PLUGIN_PREFIX); ?></a>
                		</td>
                
                		<td>
                			 <table class="form-table">
           
                               <?php
                               
                               
                               foreach ($taxonomies as $taxonomy ) {
                                 if(!$taxonomy->showui)
                                    continue; ?>
                               
                                    <tr valign="top">
                                        <td style="padding: 0;">
                                            <label for="">
                                                <?php echo $taxonomy->caption == '' ? $taxonomy->name : $taxonomy->caption ?>:
                                            </label> 
                                        </td>
                                        <td style="padding: 0;">
                                        
                                        <?php
                                        
                                        
                                        ?>
                                        
                                        <select id="<?php echo 'atkp-tax-'.$taxonomy->name.'-'.$product['asin'] ?>" style="width:300px">
                                            <option value=""><?php echo esc_attr(__('None', ATKP_PLUGIN_PREFIX)); ?></option>
                                            <?php
                                                $categories = get_categories('orderby=name&hide_empty=0&taxonomy='.$taxonomy->name);
                                                foreach ($categories as $category) {
                                                    $option = '<option value="'.$category->cat_name.'">';
                                                    $option .= $category->cat_name;
                                                    $option .= ' ('.$category->category_count.')';
                                                    $option .= '</option>';
                                                    echo $option;
                                                }
                                            ?>
                                            </select>
                                        </td>
                                    </tr>
                                <?php
                               }
                               
                               foreach ($newfields as $newfield ) {
                                   //html controls überspringen
                                   if($newfield->type == 5)
                                   continue;
                                  $fieldname = $newfield->name;
                                  
                               ?>
                               
                                    <tr valign="top">
                                        <td style="padding: 0;">
                                            <label for="">
                                                <?php echo $newfield->caption == '' ? $newfield->name : $newfield->caption ?>:
                                            </label> 
                                        </td>
                                        <td style="padding: 0;">
                                        
                                        <?php
                                        
                                        $helper->create_control($newfield, 'atkp-field-'.$fieldname.'-'.$product['asin'], null);
                                        ?>
                                        </td>
                                    </tr>
                                <?php } ?>
                                
                                </table>
                		</td>
                		
                		<td>
                		<?php
                		
                		$asin ='';
                		switch($asintype) {
                		    default:
                		    case 'ASIN':
                		        $asin = $product['asin'];
                		        break;
                		    case 'EAN':                		        
                		        $asin = $product['ean'];
                		        break;
                		    case 'TITLE':
                		        $asin = $product['title'];
                		        break;
                		    
                		}
                		if($asin != '') {
                    		 $args = array(
                                'meta_key' => ATKP_PRODUCT_POSTTYPE.'_asin',
                                'meta_value' => $asin,
                                'post_type' => ATKP_PRODUCT_POSTTYPE,
                                'post_status'      => array('publish', 'draft'),
                                'posts_per_page' => -1
                            );
                            $subposts = get_posts($args);
                		}
                        
                        echo '<div id="atkp-status-'. $product['asin'].'">';
                        
                        if(isset($subposts) && count($subposts) > 0) 
                    	    {
                    	        $myprd = $subposts[0];
                    	        
                    	        echo '<img style="vertical-align:middle" src="'.plugins_url('images/yes.png', ATKP_PLUGIN_FILE).'" alt="'.__('Imported', ATKP_PLUGIN_PREFIX).'"/>';
                                echo '<a style="margin-left:5px" href="'.get_edit_post_link($myprd->ID).'" target="_blank">'.__('Product imported.', ATKP_PLUGIN_PREFIX).'</a><br />';
                                
                            }
                            
                        echo '</div>';
                		
                		
                		
                		
                		?>
                		
                			<input <?php echo $asin == '' ? 'disabled': '' ?> type="button" style="margin-top:5px" id="atkp-draft-<?php echo $product['asin'] ?>" name="importdraft-<?php echo $product['asin'] ?>" data-shop="<?php echo $selectedshopid ?>"  data-asin="<?php echo $product['asin'] ?>" data-asin2="<?php echo $asin ?>" data-asintype="<?php echo $asintype ?>" data-status="draft" class="import-button button" title="<?php _e( 'Import as draft', ATKP_PLUGIN_PREFIX)?>" value="<?php _e( 'Import as draft', ATKP_PLUGIN_PREFIX)?>" /><br />
                			<input <?php echo $asin == '' ? 'disabled': '' ?> type="button" style="margin-top:5px" id="atkp-publish-<?php echo $product['asin'] ?>" name="importpublish-<?php echo $product['asin'] ?>" data-shop="<?php echo $selectedshopid ?>"  data-asin="<?php echo $product['asin'] ?>" data-asin2="<?php echo $asin ?>" data-asintype="<?php echo $asintype ?>" data-status="publish" class="import-button button" title="<?php _e( 'Import and publish', ATKP_PLUGIN_PREFIX)?>" value="<?php _e( 'Import and publish', ATKP_PLUGIN_PREFIX)?>" />
                			<?php if($wooenabled) ?>
                			<input <?php echo $asin == '' ? 'disabled': '' ?> type="button" style="margin-top:5px" id="atkp-woo-<?php echo $product['asin'] ?>" name="importwoo-<?php echo $product['asin'] ?>" data-shop="<?php echo $selectedshopid ?>"  data-asin="<?php echo $product['asin'] ?>" data-asin2="<?php echo $asin ?>" data-asintype="<?php echo $asintype ?>" data-status="woo" class="import-button button" title="<?php _e( 'Import for WooCommerce', ATKP_PLUGIN_PREFIX)?>" value="<?php _e( 'Import for WooCommerce', ATKP_PLUGIN_PREFIX)?>" />
                		<?php ?>
                		</td>
                
                	</tr>
                    
                    <?php
                    
                }
                
                //TODO: wenn results < 10 dann nextpage ausblenden
                ?>
                </tbody></table>
                <?php
            } catch(Exception $e) {
                echo '<span style="color:red">';
                var_dump($e);                
                echo '</span>';
                $searched =false;
            }
        }
                            
}

?>

<div style="margin:10px">
<?php if($searched) { ?>
<?php if($page > 1) { ?>
<input  style="vertical-align:middle" type="submit" style="margin-top:5px" name="lastpage" class="button primary-button" title="<?php _e( 'Last page', ATKP_PLUGIN_PREFIX)?>" value="<?php _e( 'Last page', ATKP_PLUGIN_PREFIX)?>" />
<?php } ?>

<span style="margin-left:5px;margin-right:5px">

Seite <?php echo $page; ?>

</span>
<?php if(isset($result) && count($result) >= 10) { ?>
<input  style="vertical-align:middle" type="submit" style="margin-top:5px" name="nextpage" class="button primary-button" title="<?php _e( 'Next page', ATKP_PLUGIN_PREFIX)?>" value="<?php _e( 'Next page', ATKP_PLUGIN_PREFIX)?>" />
<?php } } ?>
</div>
    
</form>



    <script type="text/javascript">
          var $j = jQuery.noConflict();
          $j(document).ready(function() {
          
          $j(".import-button").click(function(e) {
            var $asin = $j(this).attr('data-asin');
            var $asin2 = $j(this).attr('data-asin2');
            var $asintype = $j(this).attr('data-asintype');
                $j('#atkp-draft-'+$asin).prop('disabled', true);
                $j('#atkp-publish-'+$asin).prop('disabled', true);
                if ($j('#atkp-woo-'+$asin).length)
                    $j('#atkp-woo-'+$asin).prop('disabled', true);
            
                $j.ajax({
                  type: "POST",
                  url: "<?php echo ATKPTools::get_endpointurl(); ?>",
                  data: { action: "atkp_import_product", shop: $j(this).attr('data-shop'), asin:  $asin2, asintype: $asintype, title: $j('#atkp-title-'+$asin).val(), status: $j(this).attr('data-status') <?php foreach($list as $entry) { echo ', '. $entry; } ?>    , request_nonce:"<?php echo wp_create_nonce('atkp-import-nonce') ?>" },
                  
                  dataType: "json",
                  success : function(data) {
                        try {
                            if(data.length == 0)
                            {
                                alert('unknown issue');
                                return;
                            } else if(typeof data[0].error != 'undefined')
                              {
                                  alert(data[0].error+': '+data[0].message);
                              }    
                        
                            var $posturl = data[0].edit_url;
                        
                            $j('#atkp-status-'+$asin).html('<img style="vertical-align:middle" src="<?php echo plugins_url('images/yes.png', ATKP_PLUGIN_FILE) ?>" alt="<?php echo __('Imported', ATKP_PLUGIN_PREFIX) ?>"/><a style="margin-left:5px" href="'+$posturl+'" target="_blank"><?php echo __('Product imported.', ATKP_PLUGIN_PREFIX) ?></a><br />');
                            
                        } catch (err) {
                           alert(err.message);
                        }
                        
                        $j('#atkp-draft-'+$asin).prop('disabled', false);
                        $j('#atkp-publish-'+$asin).prop('disabled', false);
                        if ($j('#atkp-woo-'+$asin).length)
                            $j('#atkp-woo-'+$asin).prop('disabled', false);
                      },
                      error: function (xhr, status) {   
                        alert(xhr.responseText);
                        $j('#atkp-draft-'+$asin).prop('disabled', false);
                        $j('#atkp-publish-'+$asin).prop('disabled', false);
                        if ($j('#atkp-woo-'+$asin).length)
                            $j('#atkp-woo-'+$asin).prop('disabled', false);
                      }    
                });
            });
          });
          
    </script>




 <?php
            
}
    }
    
    
?>