<div class="atkp-container {{$parameters->cssContainerClass}}">
    @foreach ($products as $product)
    <div >
        <canvas id="canvas"></canvas>
    </div>

    <script>

        var lineChartData = {
                {!! $formatter->get_monthly_pricehistory($product, false); !!}
        };

        function format_chartnumber(nStr) {
            nStr += '';
            x = nStr.split('.');
            x1 = x[0];
            x2 = x.length > 1 ? ',' + (x[1].length == 1 ? '0'+x[1] : x[1]) : '';
            var rgx = /(\d+)(\d{3})/;
            while (rgx.test(x1)) {
                x1 = x1.replace(rgx, '$1' + '.' + '$2');
            }
            return "€ " + x1 + x2;
        }


        window.onload = function() {
            var ctx = document.getElementById('canvas').getContext('2d');
            window.myLine = Chart.Line(ctx, {
                data: lineChartData,
                options: {
                    responsive: true,
                    hoverMode: 'index',
                    stacked: false,
                    title: {
                        display: true,
                        text: '{{$translator->get_monthlypricehistorytitle()}}'
                    },
                    scales: {
                        yAxes: [{
                            type: 'linear', // only linear but allow scale type registration. This allows extensions to exist solely for log scale for instance
                            display: true,
                            position: 'left',
                            id: 'y-axis-1',
                            ticks: {
                                callback: function (nStr) {
                                    return format_chartnumber(nStr);
                                }
                            }
                        }, {
                            type: 'linear', // only linear but allow scale type registration. This allows extensions to exist solely for log scale for instance
                            display: false,
                            position: 'right',
                            id: 'y-axis-2',

                            // grid line settings
                            gridLines: {
                                drawOnChartArea: false, // only want the grid lines for one axis to show up
                            },
                        }],
                    },
                    tooltips: {
                        callbacks: {
                            label: function(tooltipItem, chart){
                                var datasetLabel = chart.datasets[tooltipItem.datasetIndex].label || '';
                                return datasetLabel + ': ' + format_chartnumber(tooltipItem.yLabel, 2);
                            }
                        }
                    }
                }
            });
        };

    </script>

    @endforeach

</div>